<template>
  <q-input
    :model-value="formattedValue"
    filled
    icon="las la-calendar"
    :label="_label"
    :hint="hint"
    :readonly="readonly"
    :rules="rules"
    hide-bottom-space
    class="date-input"
  >
    <template #append>
      <q-icon name="las la-calendar" />
    </template>
    <template #default>
      <q-popup-proxy
        @before-show="setProxyDate"
        transition-show="scale"
        transition-hide="scale"
      >
        <q-date
          v-model="proxyDate"
          mask="YYYY-MM-DD"
          today-btn
          :options="dateOptions"
          :events="dateEvents"
          :event-color="dateEventColor"
        >
          <div class="row items-center justify-end q-gutter-sm">
            <q-btn
              :label="$gettext('Cancel')"
              color="primary"
              flat
              v-close-popup
            />
            <q-btn
              :label="$gettext('OK')"
              color="primary"
              flat
              @click="onUpdateProxyDate"
              v-close-popup
            />
          </div>
        </q-date>
      </q-popup-proxy>
    </template>
  </q-input>
</template>

<script>
import { date } from 'quasar'

import { DateMixin } from 'src/mixins/DateMixin'

export default {
  name: 'DateSelectorInput',
  mixins: [DateMixin],
  props: {
    modelValue: {
      required: true,
      validator: prop => prop == null || prop instanceof Date || typeof prop === 'string'
    },
    dateOptions: {
      type: [Array, Function],
      default: undefined
    },
    dateEvents: {
      type: [Array, Function],
      default: undefined
    },
    dateEventColor: {
      type: [String, Function],
      default: 'accent'
    },
    label: {
      type: String,
      default: null
    },
    hint: {
      type: String,
      default: null
    },
    rules: {
      type: Array,
      default: null
    },
    readonly: {
      type: Boolean,
      default: true
    }
  },
  emits: ['update:model-value'],
  data () {
    return {
      proxyDate: null
    }
  },
  computed: {
    _label () {
      if (this.label !== null) {
        return this.label
      } else {
        return this.$gettext('Select a date')
      }
    },
    formattedValue () {
      if (this.modelValue !== null) {
        return this.displayDate(this.modelValue)
      } else {
        return null
      }
    }
  },
  methods: {
    setProxyDate () {
      if (this.modelValue) {
        this.proxyDate = date.formatDate(this.modelValue, 'YYYY-MM-DD')
      }
    },
    onUpdateProxyDate () {
      const proxyDate = this.proxyDate !== null ? new Date(this.proxyDate) : null
      this.$emit('update:model-value', proxyDate)
    }
  }
}
</script>

<style scoped>
.date-input :deep(.q-field__bottom) {
  display: none;
}
</style>
